Imports System.Data.SqlClient

Public Class DatabaseHelper

    Function GetDatabases(ByVal Connection As SqlConnection) As DataSet
        Dim cmd As New SqlCommand("Select * from sysdatabases order by name", Connection)
        Return ReturnDataSet(cmd)
    End Function

    Function GetTables(ByVal Database As String, _
                ByVal Connection As SqlConnection) As DataSet
        Try
            Connection.ChangeDatabase(Database)
            Dim cmd As New SqlCommand("Select  name From " & _
                "sysobjects Where xtype='U' and [Name] <> 'dtproperties' Order By name", Connection)
            Return ReturnDataSet(cmd)
        Catch ex As Exception
            MessageBox.Show(ex.Message.ToString(), _
                    Application.ProductName, _
                    MessageBoxButtons.OK, _
                    MessageBoxIcon.Information)


        End Try
    End Function

    Function GetStoredProcedures(ByVal Database As String, _
                ByVal Connection As SqlConnection) As DataSet
        Connection.ChangeDatabase(Database)
        Dim cmd As New SqlCommand("Select   name As PROCEDURE_NAME " & _
                "From sysobjects Where xtype='P' And category=0 Order By name", _
                Connection)
        Return ReturnDataSet(cmd)
    End Function

    Function GetViews(ByVal Database As String, _
                ByVal Connection As SqlConnection) As DataSet
        Connection.ChangeDatabase(Database)
        Dim cmd As New SqlCommand("Select   name As PROCEDURE_NAME " & _
                "From sysobjects Where xtype='V' And category=0 Order By name", Connection)
        Return ReturnDataSet(cmd)
    End Function

    Public Function GetStoredProcedureText(ByVal Database As String, _
                ByVal StoredProcedureName As String) As String

        If StoredProcedureName.Length > 0 Then
            If ConnectionInfo.Cn.Database <> Database Then
                ConnectionInfo.Cn.ChangeDatabase(Database)
            End If
            Dim ProcText As String
            Dim cmd As SqlCommand = New SqlCommand("sp_helptext", ConnectionInfo.Cn)
            cmd.CommandType = CommandType.StoredProcedure
            cmd.Parameters.Add("@objName", _
                        SqlDbType.NVarChar, 677).Value = StoredProcedureName
            Dim ds = ReturnDataSet(cmd)
            For Each dr As DataRow In ds.tables(0).rows
                ProcText &= dr(0)
            Next
            Return ProcText
        End If

    End Function

    Public Function GetTableSchemaInfo(ByVal Database As String, _
                ByVal TableName As String) As DataTable

        If TableName.Length > 0 Then
            ConnectionInfo.Cn.ChangeDatabase(Database)
            Dim sb As New System.Text.StringBuilder
            With sb
                .Append(" Select syscolumns.name, syscolumns.length, systypes.name, ")
                .Append(" syscolumns.isnullable ")
                .Append(" From syscolumns,sysobjects,systypes ")
                .Append(" Where  syscolumns.id = sysobjects.id ")
                .Append(" and systypes.xusertype = syscolumns.xusertype ")
                .Append(" and sysobjects.name = '" & TableName.ToString & "'")
            End With
            Dim cmd As SqlCommand = New SqlCommand(sb.ToString, ConnectionInfo.Cn)
            Return ReturnDataSet(cmd).Tables(0)
        End If
    End Function

    Public Function GetTableData(ByVal Database As String, _
                ByVal TableName As String) As DataSet
        Try
            If TableName.Length > 0 Then
                ConnectionInfo.Cn.ChangeDatabase(Database)
                Dim cmd As SqlCommand = New SqlCommand("Select * from " & TableName, ConnectionInfo.Cn)
                Return ReturnDataSet(cmd)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message.ToString(), _
                    Application.ProductName, _
                    MessageBoxButtons.OK, _
                    MessageBoxIcon.Information)
        End Try

    End Function

    Private Function ReturnDataSet(ByVal Command As SqlCommand)
        Dim adp As New SqlDataAdapter(Command)
        Dim ds = New DataSet("TableData")
        Try
            adp.Fill(ds)
        Catch ex As Exception
            MessageBox.Show(ex.Message.ToString(), _
                    Application.ProductName, _
                    MessageBoxButtons.OK, _
                    MessageBoxIcon.Information)
        End Try

        Return ds
    End Function

End Class
